macroScript Constrainer
category:"KFScripts" 
toolTip:"Constrainer" 
buttonText:"Constrainer"
-----------------------------
-----v.03 of Constrainer-----
---Written by Kiel Figgins---
-----www.3dfiggins.com-------
-----------------------------
--Automated interface for Constraining objects
--You can use it on objects with their transforms frozen or not frozen.  
--If you select multiple objects, the last one you select will have the constraint applied to it, 
--and the previous now are targets for that constraint.
--------------------
--Version History
--------------------
-----
--V.03
--Cleaned up lose ends, Added 'Both' Constrain options
-----
--V.02
--Defined global variables
-----
--V.01
--Orginal script

(
try(destroydialog Constrainer)catch()
rollout Constrainer "Constrainer" width:80 height:237
(
	button btnFreezer "Freezer" pos:[3,3] width:73 height:17
	button btnFrzTrans "Trans" pos:[3,23] width:35 height:17
	button btnFrzRot "Rot" pos:[41,23] width:35 height:17
	label lbl1 "----------------------" pos:[6,42] width:68 height:10
	checkbox chkOffsetPoint "Keep Offset" pos:[3,53] width:74 height:17 checked:true
	button btnPoint "Point Const" pos:[3,71] width:73 height:17
	button btnFrzPoint "Frz and Point" pos:[3,92] width:73 height:17
	label lbl2 "----------------------" pos:[6,110] width:68 height:10
	checkbox chkOffsetOrient "Keep Offset" pos:[3,121] width:74 height:17 checked:true
	button btnOrient "Orient Const" pos:[3,139] width:73 height:17
	button btnFrzOrient "Frz and Orient" pos:[3,160] width:73 height:17
	label lbl3 "----------------------" pos:[6,179] width:68 height:10
	button btnBoth "Both Const" pos:[3,193] width:73 height:17
	button btnFrzBoth "Both Frz Const" pos:[3,214] width:73 height:17
-----------------------
--Variables
-----------------------
global varOffsetPoint = 1
global varOffsetOrient = 1
global constArray
global constCount
global consted
global constFinder

-----------------------
--Functions
-----------------------
fn KFFreeze = 	
	( 		
		local Obj = Selection as array 		
		for i = 1 to Obj.count do 		
		( 
			Try
			(	
				local CurObj = Obj[i] 	
	
				-- freeze rotation		
				CurObj.rotation.controller = Euler_Xyz() 		
				CurObj.rotation.controller = Rotation_list() 			
				CurObj.rotation.controller.available.controller = Euler_xyz() 		
				
				/* "Localization on" */  
			
				CurObj.rotation.controller.setname 1 "Initial Pose" 		
				CurObj.rotation.controller.setname 2 "Keyframe XYZ" 		
			
				/* "Localization off" */  
				
				CurObj.rotation.controller.SetActive 2 		
	
				-- freeze position
				CurObj.position.controller = Bezier_Position() 			
				CurObj.position.controller = position_list() 			
				CurObj.position.controller.available.controller = Position_XYZ() 	
	
				/* "Localization on" */  
						
				CurObj.position.controller.setname 1 "Frozen Position" 	
				CurObj.position.controller.setname 2 "Zero Pos XYZ" 			
				
				/* "Localization off" */  
				
				CurObj.position.controller.SetActive 2 		
	
				-- position to zero
				CurObj.Position.controller[2].x_Position = 0
				CurObj.Position.controller[2].y_Position = 0
				CurObj.Position.controller[2].z_Position = 0
			)	
			/* "Localization on" */  
					
			Catch( messagebox "A failure occurred while freezing an object's transform." title:"Freeze Transform")
					
			/* "Localization off" */  	
		)
		select Obj

	)

on btnFreezer pressed do
(
KFFreeze()
macros.run "Animation Tools" "FreezeRotation"
)
on btnFrzTrans pressed do
(
KFFreeze()
)
on btnFrzRot pressed do
(
macros.run "Animation Tools" "FreezeRotation"
)

on chkOffsetPoint changed state do
	(
	if varOffsetPoint == 1 
		then
 		(varOffsetPoint = 0)
		else
		(varOffsetPoint = 1)
	)

on chkOffsetOrient changed state do
	(
	if varOffsetOrient == 1 
		then
 		(varOffsetOrient = 0)
		else
		(varOffsetOrient = 1)
	)

on btnPoint pressed do
(
try(
selNum = selection.count
if selNum == 0
	then(print "Please Make Selection"
		)
	else(
		if selNum == 1
			then(
				constFinder = $.pos.controller as string
				if constFinder == "Controller:Position_XYZ"
					then(
						$.pos.controller = Position_Constraint ()
						setCommandPanelTaskMode #motion
						if varOffsetPoint == 1 
							then($.pos.controller.relative = on)
							else($.pos.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Position_List"
							then(
								$.pos.controller.Available.controller = Position_Constraint ()
								if varOffsetPoint == 1
									then($.pos.controller.Position_Constraint.controller.relative = on)
									else($.pos.controller.Position_Constraint.controller.relative = off)
								$.pos.controller.SetActive 3
								setCommandPanelTaskMode #motion
								)
							else(
								print "Unknown Constraint Type"
								)
						)
					)
			else(
				constArray = selection as array
				constCount = constArray.count
				consted = execute("constArray"+"["+constCount as string+"]")
				constFinder = consted.pos.controller as string
				if constFinder == "Controller:Position_XYZ"
					then(
						consted.pos.controller = Position_Constraint ()
							for i=1 to constCount do
							(
							consted.pos.controller.appendTarget constArray[i] 10.0
							)
						setCommandPanelTaskMode #motion
						if varOffsetPoint == 1
							then(consted.pos.controller.relative = on)
							else(consted.pos.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Position_List"
							then(
								consted.pos.controller.Available.controller = Position_Constraint ()
								consted.pos.controller.SetActive 3
									for i=1 to constCount do
									(
									consted.pos.controller.Position_Constraint.controller.appendTarget constArray[i] 10.0
									)
								setCommandPanelTaskMode #motion
								if varOffsetPoint == 1
									then(consted.pos.controller.Position_Constraint.controller.relative = on)
									else(consted.pos.controller.Position_Constraint.controller.relative = off)
								)
							else(
								print "Unknown Constraint Type"
								)
						)
						select consted
					)
	
			)	
) catch()
)--End of btnPoint

on btnFrzPoint pressed do
(
try(
KFFreeze()
selNum = selection.count
if selNum == 0
	then(print "Please Make Selection"
		)
	else(
		if selNum == 1
			then(
				constFinder = $.pos.controller as string
				if constFinder == "Controller:Position_XYZ"
					then(
						$.pos.controller = Position_Constraint ()
						setCommandPanelTaskMode #motion
						if varOffsetPoint == 1 
							then($.pos.controller.relative = on)
							else($.pos.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Position_List"
							then(
								$.pos.controller.Available.controller = Position_Constraint ()
								if varOffsetPoint == 1
									then($.pos.controller.Position_Constraint.controller.relative = on)
									else($.pos.controller.Position_Constraint.controller.relative = off)
								$.pos.controller.SetActive 3
								setCommandPanelTaskMode #motion
								)
							else(
								print "Unknown Constraint Type"
								)
						)
					)
			else(
				constArray = selection as array
				constCount = constArray.count
				consted = execute("constArray"+"["+constCount as string+"]")
				constFinder = consted.pos.controller as string
				if constFinder == "Controller:Position_XYZ"
					then(
						consted.pos.controller = Position_Constraint ()
							for i=1 to constCount do
							(
							consted.pos.controller.appendTarget constArray[i] 10.0
							)
						setCommandPanelTaskMode #motion
						if varOffsetPoint == 1
							then(consted.pos.controller.relative = on)
							else(consted.pos.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Position_List"
							then(
								consted.pos.controller.Available.controller = Position_Constraint ()
								consted.pos.controller.SetActive 3
									for i=1 to constCount do
									(
									consted.pos.controller.Position_Constraint.controller.appendTarget constArray[i] 10.0
									)
								setCommandPanelTaskMode #motion
								if varOffsetPoint == 1
									then(consted.pos.controller.Position_Constraint.controller.relative = on)
									else(consted.pos.controller.Position_Constraint.controller.relative = off)
								)
							else(
								print "Unknown Constraint Type"
								)
						)
						select consted
					)
	
			)	
) catch()
)--End of btnFrzPoint


on btnOrient pressed do
(
try(
selNum = selection.count
if selNum == 0
	then(print "Please Make Selection"
		)
	else(
		if selNum == 1
			then(
				constFinder = $.rotation.controller as string
				if constFinder == "Controller:Euler_XYZ"
					then(
						$.rotation.controller = Orientation_Constraint ()
						setCommandPanelTaskMode #motion
						if varOffsetOrient == 1 
							then($.rotation.controller.relative = on)
							else($.rotation.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Rotation_List"
							then(
								$.rotation.controller.Available.controller = Orientation_Constraint ()
								if varOffsetOrient == 1
									then($.rotation.controller.Orientation_Constraint.controller.relative = on)
									else($.rotation.controller.Orientation_Constraint.controller.relative = off)
								$.rotation.controller.SetActive 3
								setCommandPanelTaskMode #motion
								)
							else(
								print "Unknown Constraint Type"
								)
						)
					)
			else(
				constArray = selection as array
				constCount = constArray.count
				consted = execute("constArray"+"["+constCount as string+"]")
				constFinder = consted.rotation.controller as string
				if constFinder == "Controller:Euler_XYZ"
					then(
						consted.rotation.controller = Orientation_Constraint ()
							for i=1 to constCount do
							(
							consted.rotation.controller.appendTarget constArray[i] 10.0
							)
						setCommandPanelTaskMode #motion
						if varOffsetOrient == 1
							then(consted.rotation.controller.relative = on)
							else(consted.rotation.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Rotation_List"
							then(
								consted.rotation.controller.Available.controller = Orientation_Constraint ()
								consted.rotation.controller.SetActive 3
									for i=1 to constCount do
									(
									consted.rotation.controller.Orientation_Constraint.controller.appendTarget constArray[i] 10.0
									)
								setCommandPanelTaskMode #motion
								if varOffsetOrient == 1
									then(consted.rotation.controller.Orientation_Constraint.controller.relative = on)
									else(consted.rotation.controller.Orientation_Constraint.controller.relative = off)
								)
							else(
								print "Unknown Constraint Type"
								)
						)
						select consted
					)
	
			)	
) catch()
)--End of btnOrient

on btnFrzOrient pressed do
(
try(
KFFreeze()
selNum = selection.count
if selNum == 0
	then(print "Please Make Selection"
		)
	else(
		if selNum == 1
			then(
				constFinder = $.rotation.controller as string
				if constFinder == "Controller:Euler_XYZ"
					then(
						$.rotation.controller = Orientation_Constraint ()
						setCommandPanelTaskMode #motion
						if varOffsetOrient == 1 
							then($.rotation.controller.relative = on)
							else($.rotation.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Rotation_List"
							then(
								$.rotation.controller.Available.controller = Orientation_Constraint ()
								if varOffsetOrient == 1
									then($.rotation.controller.Orientation_Constraint.controller.relative = on)
									else($.rotation.controller.Orientation_Constraint.controller.relative = off)
								$.rotation.controller.SetActive 3
								setCommandPanelTaskMode #motion
								)
							else(
								print "Unknown Constraint Type"
								)
						)
					)
			else(
				constArray = selection as array
				constCount = constArray.count
				consted = execute("constArray"+"["+constCount as string+"]")
				constFinder = consted.rotation.controller as string
				if constFinder == "Controller:Euler_XYZ"
					then(
						consted.rotation.controller = Orientation_Constraint ()
							for i=1 to constCount do
							(
							consted.rotation.controller.appendTarget constArray[i] 10.0
							)
						setCommandPanelTaskMode #motion
						if varOffsetOrient == 1
							then(consted.rotation.controller.relative = on)
							else(consted.rotation.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Rotation_List"
							then(
								consted.rotation.controller.Available.controller = Orientation_Constraint ()
								consted.rotation.controller.SetActive 3
									for i=1 to constCount do
									(
									consted.rotation.controller.Orientation_Constraint.controller.appendTarget constArray[i] 10.0
									)
								setCommandPanelTaskMode #motion
								if varOffsetOrient == 1
									then(consted.rotation.controller.Orientation_Constraint.controller.relative = on)
									else(consted.rotation.controller.Orientation_Constraint.controller.relative = off)
								)
							else(
								print "Unknown Constraint Type"
								)
						)
						select consted
					)
	
			)	
) catch()
)--End of btnFrzOrient

on btnBoth pressed do
(
try(
selNum = selection.count
if selNum == 0
	then(print "Please Make Selection"
		)
	else(
		if selNum == 1
			then(
				constFinder = $.pos.controller as string
				if constFinder == "Controller:Position_XYZ"
					then(
						$.pos.controller = Position_Constraint ()
						setCommandPanelTaskMode #motion
						if varOffsetPoint == 1 
							then($.pos.controller.relative = on)
							else($.pos.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Position_List"
							then(
								$.pos.controller.Available.controller = Position_Constraint ()
								if varOffsetPoint == 1
									then($.pos.controller.Position_Constraint.controller.relative = on)
									else($.pos.controller.Position_Constraint.controller.relative = off)
								$.pos.controller.SetActive 3
								setCommandPanelTaskMode #motion
								)
							else(
								print "Unknown Constraint Type"
								)
						)
					)
			else(
				constArray = selection as array
				constCount = constArray.count
				consted = execute("constArray"+"["+constCount as string+"]")
				constFinder = consted.pos.controller as string
				if constFinder == "Controller:Position_XYZ"
					then(
						consted.pos.controller = Position_Constraint ()
							for i=1 to constCount do
							(
							consted.pos.controller.appendTarget constArray[i] 10.0
							)
						setCommandPanelTaskMode #motion
						if varOffsetPoint == 1
							then(consted.pos.controller.relative = on)
							else(consted.pos.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Position_List"
							then(
								consted.pos.controller.Available.controller = Position_Constraint ()
								consted.pos.controller.SetActive 3
									for i=1 to constCount do
									(
									consted.pos.controller.Position_Constraint.controller.appendTarget constArray[i] 10.0
									)
								setCommandPanelTaskMode #motion
								if varOffsetPoint == 1
									then(consted.pos.controller.Position_Constraint.controller.relative = on)
									else(consted.pos.controller.Position_Constraint.controller.relative = off)
								)
							else(
								print "Unknown Constraint Type"
								)
						)
					)
	
			)	
selNum = selection.count
if selNum == 0
	then()
	else(
		if selNum == 1
			then(
				constFinder = $.rotation.controller as string
				if constFinder == "Controller:Euler_XYZ"
					then(
						$.rotation.controller = Orientation_Constraint ()
						setCommandPanelTaskMode #motion
						if varOffsetOrient == 1 
							then($.rotation.controller.relative = on)
							else($.rotation.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Rotation_List"
							then(
								$.rotation.controller.Available.controller = Orientation_Constraint ()
								if varOffsetOrient == 1
									then($.rotation.controller.Orientation_Constraint.controller.relative = on)
									else($.rotation.controller.Orientation_Constraint.controller.relative = off)
								$.rotation.controller.SetActive 3
								setCommandPanelTaskMode #motion
								)
							else(
								print "Unknown Constraint Type"
								)
						)
					)
			else(
				constArray = selection as array
				constCount = constArray.count
				consted = execute("constArray"+"["+constCount as string+"]")
				constFinder = consted.rotation.controller as string
				if constFinder == "Controller:Euler_XYZ"
					then(
						consted.rotation.controller = Orientation_Constraint ()
							for i=1 to constCount do
							(
							consted.rotation.controller.appendTarget constArray[i] 10.0
							)
						setCommandPanelTaskMode #motion
						if varOffsetOrient == 1
							then(consted.rotation.controller.relative = on)
							else(consted.rotation.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Rotation_List"
							then(
								consted.rotation.controller.Available.controller = Orientation_Constraint ()
								consted.rotation.controller.SetActive 3
									for i=1 to constCount do
									(
									consted.rotation.controller.Orientation_Constraint.controller.appendTarget constArray[i] 10.0
									)
								setCommandPanelTaskMode #motion
								if varOffsetOrient == 1
									then(consted.rotation.controller.Orientation_Constraint.controller.relative = on)
									else(consted.rotation.controller.Orientation_Constraint.controller.relative = off)
								)
							else(
								print "Unknown Constraint Type"
								)
						)
						select consted
					)
	
			)	
) catch()
)--End of btnBoth

on btnFrzBoth pressed do
(
KFFreeze()
selNum = selection.count
if selNum == 0
	then(print "Please Make Selection"
		)
	else(
		if selNum == 1
			then(
				constFinder = $.pos.controller as string
				if constFinder == "Controller:Position_XYZ"
					then(
						$.pos.controller = Position_Constraint ()
						setCommandPanelTaskMode #motion
						if varOffsetPoint == 1 
							then($.pos.controller.relative = on)
							else($.pos.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Position_List"
							then(
								$.pos.controller.Available.controller = Position_Constraint ()
								if varOffsetPoint == 1
									then($.pos.controller.Position_Constraint.controller.relative = on)
									else($.pos.controller.Position_Constraint.controller.relative = off)
								$.pos.controller.SetActive 3
								setCommandPanelTaskMode #motion
								)
							else(
								print "Unknown Constraint Type"
								)
						)
					)
			else(
				constArray = selection as array
				constCount = constArray.count
				consted = execute("constArray"+"["+constCount as string+"]")
				constFinder = consted.pos.controller as string
				if constFinder == "Controller:Position_XYZ"
					then(
						consted.pos.controller = Position_Constraint ()
							for i=1 to constCount do
							(
							consted.pos.controller.appendTarget constArray[i] 10.0
							)
						setCommandPanelTaskMode #motion
						if varOffsetPoint == 1
							then(consted.pos.controller.relative = on)
							else(consted.pos.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Position_List"
							then(
								consted.pos.controller.Available.controller = Position_Constraint ()
								consted.pos.controller.SetActive 3
									for i=1 to constCount do
									(
									consted.pos.controller.Position_Constraint.controller.appendTarget constArray[i] 10.0
									)
								setCommandPanelTaskMode #motion
								if varOffsetPoint == 1
									then(consted.pos.controller.Position_Constraint.controller.relative = on)
									else(consted.pos.controller.Position_Constraint.controller.relative = off)
								)
							else(
								print "Unknown Constraint Type"
								)
						)
					)
	
			)	
selNum = selection.count
if selNum == 0
	then()
	else(
		if selNum == 1
			then(
				constFinder = $.rotation.controller as string
				if constFinder == "Controller:Euler_XYZ"
					then(
						$.rotation.controller = Orientation_Constraint ()
						setCommandPanelTaskMode #motion
						if varOffsetOrient == 1 
							then($.rotation.controller.relative = on)
							else($.rotation.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Rotation_List"
							then(
								$.rotation.controller.Available.controller = Orientation_Constraint ()
								if varOffsetOrient == 1
									then($.rotation.controller.Orientation_Constraint.controller.relative = on)
									else($.rotation.controller.Orientation_Constraint.controller.relative = off)
								$.rotation.controller.SetActive 3
								setCommandPanelTaskMode #motion
								)
							else(
								print "Unknown Constraint Type"
								)
						)
					)
			else(
				constArray = selection as array
				constCount = constArray.count
				consted = execute("constArray"+"["+constCount as string+"]")
				constFinder = consted.rotation.controller as string
				if constFinder == "Controller:Euler_XYZ"
					then(
						consted.rotation.controller = Orientation_Constraint ()
							for i=1 to constCount do
							(
							consted.rotation.controller.appendTarget constArray[i] 10.0
							)
						setCommandPanelTaskMode #motion
						if varOffsetOrient == 1
							then(consted.rotation.controller.relative = on)
							else(consted.rotation.controller.relative = off)
						)
					else(
						if constFinder == "Controller:Rotation_List"
							then(
								consted.rotation.controller.Available.controller = Orientation_Constraint ()
								consted.rotation.controller.SetActive 3
									for i=1 to constCount do
									(
									consted.rotation.controller.Orientation_Constraint.controller.appendTarget constArray[i] 10.0
									)
								setCommandPanelTaskMode #motion
								if varOffsetOrient == 1
									then(consted.rotation.controller.Orientation_Constraint.controller.relative = on)
									else(consted.rotation.controller.Orientation_Constraint.controller.relative = off)
								)
							else(
								print "Unknown Constraint Type"
								)
						)
						select consted
					)
)

)--End of btnFrzBoth

)--End of Script
createDialog Constrainer pos:[1220,80]
)--End of Macro
